# -*- coding: utf-8 -*-

import sys
import io
import difflib
from itertools import islice

def readfile(filename):
    with io.open(filename, encoding='utf-8') as fd:
        for line in fd:
            yield line.rstrip('\n')

def dodiff(file0, file1, tail):
    l0 = tuple(islice(readfile(file0), tail))
    l1 = tuple(islice(readfile(file1), tail))

    for line in difflib.context_diff(l0, l1, fromfile='file0', tofile='file1', n=0):
        sys.stdout.write('%s\n' % line)

if __name__ == '__main__':
    '''
        before.txt and after.txt ONLY differ in three lines: 1, 26 and 48

        python before.txt after.txt 100 > gives correct result
        python before.txt after.txt 200 > gives wrong result
    '''

    args = sys.argv[1:]
    n0, n1, gap = args
    dodiff(n0, n1, int(gap))
